### Method

# Gio InputStream read

#### Declaration [src]

    gssize
    g_input_stream_read (
      GInputStream* stream,
      void* buffer,
      gsize count,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Tries to read `count` bytes from the stream into the buffer starting at `buffer`. Will block during this read.

If count is zero returns zero and does nothing. A value of `count` larger than `G_MAXSSIZE` will cause a `G_IO_ERROR_INVALID_ARGUMENT` error.

On success, the number of bytes read into the buffer is returned. It is not an error if this is not the same as the requested size, as it can happen e.g. near the end of a file. Zero is returned on end of file (or if `count` is zero), but never otherwise.

The returned `buffer` is not a nul-terminated string, it can contain nul bytes at any position, and this function doesn’t nul-terminate the `buffer`.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned. If an operation was partially finished when the operation was cancelled the partial result will be returned, without an error.

On error -1 is returned and `error` is set accordingly.

#### Parameters

`buffer`

  Type: An array of `guint8`

  a buffer to read data into (which should be at least count bytes long).

  The argument will be set by the function.
  The length of the array is specified in the `count` argument.
  The returned data is owned by the instance.

`count`

  Type: `gsize`

  The number of bytes that will be read from the stream.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gssize`

Number of bytes read, or -1 on error, or 0 on end of file.